import { api } from '@/services/api';
import { request } from '@umijs/max';
/**获取客户列表 */
export async function getCustoms(params: {
    corpId: any,//企业ID
    corpUserId: any,//客服ID
    openId: any,//客户
    pageNum: number,//
    pageSize: number
}) {
    return request(api + '/admin/corp/getCustoms', {
        method: 'GET',
        params
    });
}
type Params = {
    appId: string,
    appType: any,
    pageNum: number,//
    pageSize: number
}
/**已授权企微客服列表 */
export async function getAllBindKfs(params: Params) {
    return request(api + '/admin/corp/getAllBindKfs', {
        method: 'GET',
        params
    });
}
/**未授权企微客服列表 */
export async function getAllAvailableKfs(params: Params) {
    return request(api + '/admin/corp/getAllAvailableKfs', {
        method: 'GET',
        params
    });
}
/**批量授权客服号给指定小程序 */
export async function configUser(data: {
    corpId: any,
    corpUserIds: any[],
    appId: any,
    appType: any
}) {
    return request(api + '/admin/corp/configUser', {
        method: 'PUT',
        data
    });
}
/**取消授权 */
export async function revoke(data: {
    corpId: any,
    corpUserIds: any[],
    appId: any,
    appType: any
}) {
    return request(api + '/admin/corp/revoke', {
        method: 'PUT',
        data
    });
}


/**欢迎语列表 */
export async function corpWelcomeMsgList(data:{
    appId: number,
    appType: number,
    welcomeType: number,//0：定位身份用户；1：定位产品用户；2：其他用户
}) {
    return request(api + '/admin/corpWelcomeMsg/list', {
        method: 'POST',
        data
    });
}
/**新增修改欢迎语 */
export async function corpWelcomeMsgAddOrUpdate(data:  {
    appId: number,
    appType: number,
    mediaContentList: {
        id: number,
        mediaType: string,//素材类型
        textContent: string,//文本内容
        imageUrl: string,//图片oss地址
        linkTitle: string,//图文标题
        linkPicurl: string,//图文封面oss地址
        linkDesc: string,//图文描述
        linkUrl: string,//图文链接
        miniprogramTitle: string,//小程序标题
        miniprogramPicurl: string,//小程序封面oss地址
        miniprogramAppid: string,//小程序appid
        miniprogramPage: string//小程序page路径oss地址
    }[],
    welcomeType: number,//0：定位身份用户；1：定位产品用户；2：其他用户
    remark: string//备注
}) {
    return request(api + '/admin/corpWelcomeMsg/addOrUpdate', {
        method: 'POST',
        data
    });
}